import { Output as WebpackOutputOptions, Plugin, Configuration as WebpackConfiguration, RuleSetRule } from 'webpack';
export declare type ConfigurationMode = 'development' | 'production' | 'none';
export declare type Hook = (plebpack: Plebpack) => void;
export declare type HookSet = {
    run: Hook;
    position: number;
};
export declare type PluginSet = {
    plugin: Plugin;
    priority: number;
    position?: number;
};
export declare class Plebpack {
    private pkg?;
    mode: ConfigurationMode;
    private debug;
    private hooks;
    private context;
    private entries;
    private output?;
    private aliases;
    private plugins;
    private loaders;
    private extensions;
    private resolvePaths;
    private externals;
    private configs;
    constructor(pkg?: string | null | undefined);
    getPkg(): string | null | undefined;
    setDebug(debug: boolean): void;
    use(...hooks: Hook[]): void;
    addEntry(name: string, path: string): void;
    getEntries(): Record<string, any>;
    setOutput(output: WebpackOutputOptions): void;
    getOutput(): WebpackOutputOptions;
    setContext(context: string): void;
    getContext(): string;
    addAlias(alias: string, path: string): void;
    getAliases(): Record<string, any>;
    addPlugin(plugin: Plugin, priority?: number): void;
    getPlugins(): Plugin[];
    addLoader(loader: RuleSetRule): void;
    getLoaders(): RuleSetRule[];
    addExtension(extension: string): void;
    getExtensions(): string[] | undefined;
    addResolvePath(path: string): void;
    getResolvePaths(): string[] | undefined;
    addExternal(name: string, path: string): void;
    getExternals(): Record<string, any>;
    merge(config: Record<string, any> | Function): void;
    getConfigs(): Set<Function>;
    config(mode: ConfigurationMode): WebpackConfiguration;
}
//# sourceMappingURL=plebpack.d.ts.map